# transform.py
# ------------
# By MWC Contributors
# The functions in this module transform data. 
# None of them are finished; this is your job!

def maximum(data):
    "Returns the largest number in data"
    highest = None
    for number in data:
        if highest is None:
            highest = number
        if number > highest:
            highest = number
    return highest

def minimum(data):
    "Returns the smallest number in data"
    lowest = None
    for number in data:
        if lowest is None:
            lowest = number
        if number < lowest:
            lowest = number
    return lowest
        

            

def bounds(data):
    "Returns a list of the smallest and largest numbers in data"
    bounds = [minimum(data),maximum(data)]
    return bounds

def clamp(value, low, high):
    """Clamps a value to a range from low to high. 
    Returns value if it is between low and high.
    If value is lower than low, returns low. If value is higher than high, returns high.
    """
    #if low < value < high:
     #   return value
    if low < value and value < high:
        return value
    if value < low:
        return low
    if value > high:
        return high
    if value == low:
        return low
    if value == high:
        return high

def ratio(value, start, end):
    """Returns a number from 0.0 to 1.0, representing how far along value is from start to end.
    The return value is clamped to [0, 1], so even if value is lower than start, the return 
    value will not be lower than 0.0.
    """
    r = (value - start)/(end - start)
    return clamp(r,0,1)       
    

def scale(value, domain_min, domain_max, range_min, range_max):
    "Given a value within a domain, returns the scaled equivalent within range."
    ratio_2 = ratio(value, domain_min, domain_max)
    scaley = range_min + ratio_2 *(range_max - range_min)
    return scaley

def get_x_values(points):
    "Returns the first value for each point in points."
    x_values = []
    for x, y in points:
        x_values.append(x)
    return x_values

def get_y_values(points):
    "Returns the second value for each point in points."
    y_values = []
    for x, y in points:
        y_values.append(y)
    return y_values
